//--------------------------------------------------------------------
// WKMascot State/_EH[N 
//--------------------------------------------------------------------

require("STWaitIdle.nut");

//====================================================================
// NX錾
//====================================================================

class STRandomWalk {

	STWaitIdle = STWaitIdle;

	m_MoveToX = 0;
	m_MoveToZ = 0;

	function constructor() {
		m_MoveToX = 0;
		m_MoveToZ = 0;
	}

}

//-----------------------------------------------
// 
//-----------------------------------------------

function new() {

	return STRandomWalk();

}


//====================================================================
// Xe[g
//====================================================================

//-----------------------------------------------
// Jn
//-----------------------------------------------

function STRandomWalk::Start( mascot ) {

	local wx = cpp_GetWorldSizeX();
	local wy = cpp_GetWorldSizeY();
	local wz = cpp_GetWorldSizeZ();

	local dx = wx - 2000; //(1mƂ)̃TCY 
	local dz = wz - 2000; //(1mƂ)̃TCY

	m_MoveToX = frand() * dx - dx / 2;
	m_MoveToZ = frand() * dz - dz / 2;

	mascot.SetMotion( "walk" );

}

//-----------------------------------------------
// I
//-----------------------------------------------

function STRandomWalk::End( mascot ) {

}

//-----------------------------------------------
// [v
//-----------------------------------------------

function STRandomWalk::Loop( mascot ) {

	//ݒ
	local posx = mascot.GetPosX();
	local posy = mascot.GetPosY();
	local posz = mascot.GetPosZ();
	local dx = m_MoveToX - posx;
	local dz = m_MoveToZ - posz;

	if( dx * dx + dz * dz < 200 * 200 ) {

		mascot.ChangeState( STWaitIdle.new() );

	} else {

		local dir = atan2( dx, dz );
		mascot.SetDir( dir, 200 );

	}

}

